#(define noStandaloneOutput (if (defined? 'noStandaloneOutput) noStandaloneOutput #f))

#(define windows? (string-prefix-ci? "windows" (utsname:sysname (uname))))

#(if (defined? 'LAYOUT) #f
  (let ((scmdir
         (if windows?
           (string-append "scm" file-name-separator-string)
          (string-append (dirname (current-filename)) file-name-separator-string "scm" file-name-separator-string)
         )))
    (load (string-append scmdir "json_parser.scm"))
    (load (string-append scmdir "resolve_inherits.scm"))
    (load (string-append scmdir "yaml_parser.scm"))))
#(define AUTHOR_DATA (if (defined? 'AUTHOR_DATA) AUTHOR_DATA (parse-yml-file "../../lilypond-song-includes/data/authors.yml")))
#(define SONG_DATA (if (defined? 'SONG_DATA) SONG_DATA (parse-yml-file "../../lilypond-song-includes/data/songs.yml")))

\include "basic_format_and_style_settings.ly"
\include "eps_file_from_song_dir.ly"
\include "title_with_category_images.ly"
\include "chord_settings.ly"
\include "transposition.ly"
\include "verses_with_chords.ly"
\include "arrows_in_scores.ly"
\include "swing_style.ly"
\include "inline_score.ly"

% reset important variables
LAYOUT = \layout { \generalLayout }
HEADER = {}
MUSIC = {}
TEXT = \markuplist {""}

verseChords = {}
firstVoice = {}
global = {}
